//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.ListDataTypeTest
{
    
    
    /// <summary>
    /// A class that exposes the IListDataTypeTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class ListDataTypeTestProvider : IFeatureProvider
    {
        
        private IListDataTypeTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(ListDataTypeTestProvider).Assembly, "ListDataTypeTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public ListDataTypeTestProvider(IListDataTypeTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<EchoStringListRequestDto, EchoStringListResponseDto>("EchoStringList", EchoStringList);
            registration.RegisterUnobservableCommand<EchoIntegerListRequestDto, EchoIntegerListResponseDto>("EchoIntegerList", EchoIntegerList);
            registration.RegisterUnobservableCommand<EchoStructureListRequestDto, EchoStructureListResponseDto>("EchoStructureList", EchoStructureList);
            registration.RegisterUnobservableProperty("EmptyStringList", GetEmptyStringList);
            registration.RegisterUnobservableProperty("StringList", GetStringList);
            registration.RegisterUnobservableProperty("IntegerList", GetIntegerList);
            registration.RegisterUnobservableProperty("StructureList", GetStructureList);
        }
        
        /// <summary>
        /// Executes the Echo String List command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoStringListResponseDto EchoStringList(EchoStringListRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoStringListResponseDto(_implementation.EchoStringList(request.StringList.TryExtract(_server, "org.silastandard/test/ListDataTypeTest/v1/Command/EchoStringList/Parameter/String" +
                                "List")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "stringList"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/ListDataTypeTest/v1/Command/EchoStringList/Parameter/String" +
                            "List", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Echo Integer List command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoIntegerListResponseDto EchoIntegerList(EchoIntegerListRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoIntegerListResponseDto(_implementation.EchoIntegerList(request.IntegerList.TryExtract(_server, "org.silastandard/test/ListDataTypeTest/v1/Command/EchoIntegerList/Parameter/Integ" +
                                "erList")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "integerList"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/ListDataTypeTest/v1/Command/EchoIntegerList/Parameter/Integ" +
                            "erList", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Echo Structure List command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoStructureListResponseDto EchoStructureList(EchoStructureListRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoStructureListResponseDto(_implementation.EchoStructureList(request.StructureList.TryExtract(_server, "org.silastandard/test/ListDataTypeTest/v1/Command/EchoStructureList/Parameter/Str" +
                                "uctureList")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "structureList"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/ListDataTypeTest/v1/Command/EchoStructureList/Parameter/Str" +
                            "uctureList", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Empty String List property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.StringDto>> GetEmptyStringList()
        {
            return new PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.StringDto>>(Tecan.Sila2.DtoExtensions.Encapsulate(_implementation.EmptyStringList, Tecan.Sila2.StringDto.Create, _server));
        }
        
        /// <summary>
        /// Gets the current value of the String List property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.StringDto>> GetStringList()
        {
            return new PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.StringDto>>(Tecan.Sila2.DtoExtensions.Encapsulate(_implementation.StringList, Tecan.Sila2.StringDto.Create, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Integer List property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.IntegerDto>> GetIntegerList()
        {
            return new PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.IntegerDto>>(Tecan.Sila2.DtoExtensions.Encapsulate(_implementation.IntegerList, Tecan.Sila2.IntegerDto.Create, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Structure List property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<System.Collections.Generic.List<TestStructureDto>> GetStructureList()
        {
            return new PropertyResponse<System.Collections.Generic.List<TestStructureDto>>(Tecan.Sila2.DtoExtensions.Encapsulate(_implementation.StructureList, TestStructureDto.Create, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/ListDataTypeTest/v1/Command/EchoStringList"))
            {
                return typeof(IListDataTypeTest).GetMethod("EchoStringList");
            }
            if ((commandIdentifier == "org.silastandard/test/ListDataTypeTest/v1/Command/EchoIntegerList"))
            {
                return typeof(IListDataTypeTest).GetMethod("EchoIntegerList");
            }
            if ((commandIdentifier == "org.silastandard/test/ListDataTypeTest/v1/Command/EchoStructureList"))
            {
                return typeof(IListDataTypeTest).GetMethod("EchoStructureList");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/test/ListDataTypeTest/v1/Property/EmptyStringList"))
            {
                return typeof(IListDataTypeTest).GetProperty("EmptyStringList");
            }
            if ((propertyIdentifier == "org.silastandard/test/ListDataTypeTest/v1/Property/StringList"))
            {
                return typeof(IListDataTypeTest).GetProperty("StringList");
            }
            if ((propertyIdentifier == "org.silastandard/test/ListDataTypeTest/v1/Property/IntegerList"))
            {
                return typeof(IListDataTypeTest).GetProperty("IntegerList");
            }
            if ((propertyIdentifier == "org.silastandard/test/ListDataTypeTest/v1/Property/StructureList"))
            {
                return typeof(IListDataTypeTest).GetProperty("StructureList");
            }
            return null;
        }
    }
}

